{ Example : parallel port command

  --------------------------------------------}
program tEx069;

// To tell FreePascal that the application is a Graphical User Interface
// i.e. is running in windows, not in text mode.
{$APPTYPE GUI}

Uses
  wApplication0
 ,wWindow0
 ,wDialog0
 ,wPopupWindow0
 ,wDialogCreatorLOW2
 ,wDialogCreator2
 ,wVariableNumLink2
 ,wWindowBase0
 ,wErrors0
 ,wGlobals2
 ,wDebug0
 ,Windows;
// ,zlportio;

const
  id_D0_OFF  = 100;
  id_D0_ON   = 101;
  id_D1_OFF  = 110;
  id_D1_ON   = 111;
  idQUIT     = 999;


type
  PMyDialog = ^TMyDialog;
  TMyDialog = object(TDialog)
  //"""""""""""""""""""""""""

  vXValue : Float;
  // the value shown in the edit box, must be different if we don't
  // want rounding errors to occure.

  fClearNext : boolean;
  // The next digit clears the avValue[1] and replaces it by the digit

  fAddNext : boolean;
  // The next digit push the stack up and
  //  clears the avValue[1] and replaces it by the digit

  vPeriode : Float;
  // If the periode has been pressed, indicate how many digits are after the
  // period.

  vMemory : Float;
  // A simple memory.

  constructor Init(poParentW:PWindowBase);

  function WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL; virtual;
  // Handles the menu messages

//  function DialogProc(hDialog:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
    // Not used
  // Handles the dialog messages. See comments in  wDialog0.pp
  end; // TMyDialog = object(TDialog)

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
  //"""""""""""""""""""""""""
  constructor Init(strWinTitlePrm:ShortString);

  destructor Done; virtual;

  procedure WinCreate(strWinClass:ShortString); virtual;
  // When creating the window, we ask to show the dialog box, not the window

  function WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
  // Handles the menu messages

//  function WindowProc(hWindow:HWND; wMsg:UINT; wPar:WPARAM; lPar:LPARAM):LRESULT; virtual;
    // Not Used
  end; // TMyWindow = object(TWindow)

var
  oApp        : TApplication;
  poMyMainWin : PMyWindow;


{
Public Declare Function InitializeElkPort Lib "ElkPortNT.dll" () As Boolean
Public Declare Sub CloseElkPort Lib "ElkPortNT.dll" ()
Public Declare Sub RemoveElkPortDriver Lib "ElkPortNT.dll" ()
    'Install le driver pour un Compte administrateur ou limit
Public Declare Sub InstalElkPortDriver Lib "ElkPortNT.dll" ()

Public Declare Function ReadByte Lib "ElkPortNT.dll" (ByVal Port As Short) As Byte
Public Declare Function WriteByte Lib "ElkPortNT.dll" (ByVal Port As Short, ByVal Value As Byte) As Boolean


Public Declare Function ReadWord Lib "ElkPortNT.dll" (ByVal Port As Short) As Short
Public Declare Function WriteWord Lib "ElkPortNT.dll" (ByVal Port As Short, ByVal Value As Short) As Boolean

Public Declare Function ReadLong Lib "ElkPortNT.dll" (ByVal Port As Short) As Integer
Public Declare Function WriteLong Lib "ElkPortNT.dll" (ByVal Port As Short, ByVal Value As Integer) As Boolean
}

procedure InstalElkPortDriver; stdcall; external 'ElkPortNT.dll' name 'InstalElkPortDriver';
  // Install le driver pour un Compte administrateur ou limit

function InitializeElkPort:boolean; stdcall; external 'ElkPortNT.dll' name 'InitializeElkPort';
procedure CloseElkPort; stdcall; external 'ElkPortNT.dll' name 'CloseElkPort';
procedure RemoveElkPortDriver; stdcall; external 'ElkPortNT.dll' name 'RemoveElkPortDriver';

procedure WriteByte(PortAddress:smallint; Value:smallint); stdcall; external 'ElkPortNT.dll' name 'WriteByte';


function myCreateDialogObj(poParent:Pointer):Pointer;
//===================================================
var poObj : PMyDialog;
begin
new(poObj, Init(poParent));
myCreateDialogObj:=poObj;
end;  // myCreateDialogObj

//******************************************************************
// TMyDialog = object(TDialog)
//******************************************************************

constructor TMyDialog.Init(poParentW:PWindowBase);
//================================================
begin
// must be done, even if it seems useless.
inherited Init(poParentW);

vXValue:=0.0;
FloatField(100, vXValue);

fClearNext :=FALSE;
fAddNext   :=FALSE;
vPeriode   :=1; // no digits after the period.
vMemory    :=0;
end;  // TMyDialog.Init

function TMyDialog.WMCommand(wPar:WPARAM; lPar:LPARAM):BOOL;
//==========================================================
// Handles the menu messages
var
  wCtrlID     : word32;
//  nn : smallint;

begin
if (HiWord(wPar) <> BN_CLICKED) then begin
   WMCommand:=inherited WMCommand(wPar, lPar);
   exit;
   end;
//DBW(1, 'WMCommand=' + DBNotifToStr(HiWord(wPar)) + ITS5(LoWord(wPar)));
wCtrlID:=LoWord(wPar);

//MessageBeep(0);

//DBW(1, 'Button clicked=' + ITS(poBtn^.wCtrlID));

// sets output D0 to 0 [V]
if (wCtrlID = id_D0_OFF) then begin
   DBW(0, 'set D0 to off');
   WriteByte($378, 0);
   end;

// sets output D0 to more than 2 [V]
if (wCtrlID = id_D0_ON) then begin
   DBW(0, 'set D0 to on');

   WriteByte($378, 1);
   end;

// Did we click on the quit button ?
// Close the main window, thus quit the application.
if (wCtrlID = idQUIT) then  PostMessage(poMyMainWin^.hWin, WM_CLOSE, 0, 0);

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyDialog.WMCommand

//******************************************************************
// TMyWindow = object(TWindow)
//******************************************************************

constructor TMyWindow.Init(strWinTitlePrm:ShortString);
//=====================================================

begin
inherited Init(strWinTitlePrm);

InstalElkPortDriver;

if not InitializeElkPort then messagebeep(0);
end;  // TMyWindow.Init

destructor TMyWindow.Done;
//========================
//var strName : string[50];
begin
//strName:='zlportio.sys' + char(0);
//driverstop(@strName[1]);

CloseElkPort;
RemoveElkPortDriver;

inherited Done;
end;

procedure TMyWindow.WinCreate(strWinClass:ShortString);
//=====================================================
//var strName : string[50];
Begin
// We don't want to see the main window
//wSizeState := SIZE_MINIMIZED;

inherited WinCreate(strWinClass);

// Here calling :  DialogExecMSG(11199, @Self);  doesn't work,
// But posting a message to open the dialog box at startup is possible.
// Opens also the help window, indicating the key action.
PostMessage(hWin, WM_COMMAND, 121, 0);
PostMessage(hWin, WM_COMMAND, 101, 0);

//strName:='zlportio' + char(0);
//DBW(0, 'result= ' + ITS(driverstart(@strName[1])));

end;  // TMyWindow.WinCreate

function TMyWindow.WMCommand(wPar:WPARAM; lPar:LPARAM):LRESULT;
//=============================================================
// There are no menus treatment, only one dialog box
begin
// Execute the dialog box at starting
// And the help window
if (lPar = 0) and (wPar =101) then DialogCreateMSG(11199, @Self);
//if (lPar = 0) and (wPar =121) then DialogCreateMSG(21199, @Self);

// Accelerators act as button click.
// Send the command to the active dialog
case LoWord(wPar) of
  idQUIT
          : if (gglpoActiveDialog <> NIL) then
               gglpoActiveDialog^.WMCommand(LoWord(wPar), 0);

  end; // case

WMCommand:=inherited WMCommand(wPar, lPar);
end;  // TMyWindow.WMCommand

//**********************************************************************
Begin // MAIN ******
// Assign the pointer on the function which will create the dialog.
// It is used by the library. So the library will construct
// a user defined object.
gglfnCreateDialogObj:=@myCreateDialogObj;

// Name under which the main window is registered. Spaces are not allowed
oApp.Init('Example069');



// Creation of the main window
new(poMyMainWin, Init('tEx069_Parallel_port_command.pp'));

// The App.WindowClass can be modified here, if wanted. (Not usual)
oApp.Run;
oApp.Done;  // The main window object is disposed here.
End.


{
AUTRE : //procedure Out32(PortAddress:smallint; Value:smallint); external 'InpOut32' name 'Out32';


type
  TInp32 = function(PortAddress: SmallInt): SmallInt; stdcall;
  TOut32 = procedure(PortAddress: SmallInt; Data: SmallInt); stdcall;

var
    hInpout32: THandle;
    Inp32: TInp32;
    Out32: TOut32;


DANS le INIT :
hInpout32 := LoadLibrary('inpout32.dll');
if (hInpout32 <> 0) then begin
   // needs overtyping, plain Delphi's @Inp32 = GetProc... leads to compile errors
   Inp32 := TInp32(GetProcAddress(hInpout32, 'Inp32'));
   if (@Inp32 = nil) then DBW(0, 'Error for Inp32');

   Out32 := TOut32(GetProcAddress(hInpout32, 'Out32'));
   if (@Out32 = nil) then DBW(0, 'Error for Out32');
  end
  else DBW(0, 'Error loading the inpout32 dll');


Dans le done : FreeLibrary(hInpout32);
}
